leetcode|最简单的一道NimGame

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

题目:这是一个游戏,假设一个石头堆里有一堆石头,两个游戏者互相取,一次能取1,2,3个,不能超过3个,取走最后一个是赢家,写一个算法,你先来能赢吗?

思路:题目加粗部分说了,假设玩家都很聪明,懂得这个游戏的最优战略,简单的分析发现,如果石头堆有4颗,你一定赢,取走两,对方只能一个,你拿最后一个,所以这个赢与否的石头数,跟4是有很大关系的,于是乎:

public boolean canWinNim(int n) {
  return n%4 !=0;
}

完。。。。

转载于:https://www.cnblogs.com/wujunjie/p/5670136.html

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值